<?php
if (!isset($_SERVER['argv'][1]) || !is_numeric($_SERVER['argv'][1]))
    die("usage: php ".basename(__FILE__)." graph_tree_id\n");

include(dirname(__FILE__) . "/../include/global.php");
include(dirname(__FILE__) . "/../lib/rrd.php");
include(dirname(__FILE__) . "/../lib/graph_variables.php");

function HumanSize($Bytes) {
  $Type=array("", "kilo", "mega", "giga", "tera", "peta", "exa", "zetta", "yotta");
  $Index=0;
  while($Bytes>=1000)
  {
    $Bytes/=1000;
    $Index++;
  }
  return("".$Bytes." ".$Type[$Index]."bytes");
}

function getTraffic($tree_id) {
    global $cp;
	$phppth=read_config_option("path_php_binary")	;
	$result=false;	
	
	//date filters    
	$start_time = strtotime(date('Y-m-01 00:00:01',strtotime('2007-01-01')));
	$end_time = strtotime(date('Y-m-d 23:59:59',(strtotime('2007-06-31'))));
	
	//data filters	
	$filter='traffic';//can be sql's "like" syntax
	
	$host_ids = db_fetch_assoc("SELECT host_id FROM tinklas.graph_tree_items where graph_tree_id=$tree_id and local_graph_id=0 and host_id!=0");

	foreach ($host_ids as $hid) {
	    $lgi=db_fetch_cell("SELECT graph_templates_graph.local_graph_id 
				FROM (graph_templates_graph,graph_local) 
				    LEFT JOIN host on (host.id=graph_local.host_id) 
				    LEFT JOIN graph_templates on (graph_templates.id=graph_local.graph_template_id) 
				    LEFT JOIN user_auth_perms on ((graph_templates_graph.local_graph_id=user_auth_perms.item_id and user_auth_perms.type=1 and user_auth_perms.user_id=18) 
					OR (host.id=user_auth_perms.item_id and user_auth_perms.type=3 and user_auth_perms.user_id=18) 
					OR (graph_templates.id=user_auth_perms.item_id and user_auth_perms.type=4 and user_auth_perms.user_id=18)) 
				WHERE ((user_auth_perms.type != 1 OR user_auth_perms.type is null) 
				    AND ((user_auth_perms.type != 3) OR (user_auth_perms.type is null)) 
				    AND ((user_auth_perms.type != 4) OR (user_auth_perms.type is null))) 
				    AND graph_templates_graph.local_graph_id > 0 
				    AND graph_templates_graph.local_graph_id=graph_local.id 
				    AND graph_templates_graph.title_cache like '%$filter%' 
				    AND graph_local.host_id=${hid['host_id']} 
				GROUP BY graph_templates_graph.local_graph_id 
				ORDER BY graph_templates_graph.title_cache");

	    $l_g_i[]['local_graph_id']=$lgi;
	}

	if (empty($l_g_i)) die("no data for tree_id=$tree_id\n");
	
	foreach ($l_g_i as $lgi) {
	    $i=0;
	    $lgi = $lgi['local_graph_id'];
	    
	    $data = db_fetch_assoc("SELECT
					graph_templates_graph.local_graph_id,
		    			data_template_data.local_data_id,
		    			graph_templates_graph.base_value,
					graph_templates_graph.title_cache
				    FROM (
		    			graph_templates_graph,
		    			data_template_data 
		    			)
				    WHERE (
		    			graph_templates_graph.title_cache=data_template_data.name_cache and 
		    			graph_templates_graph.local_graph_id=$lgi
		    		    )");
	    if (empty($data)) continue;
	    
	    $local_data_id = $data[0]['local_data_id'];
	    $local_graph_id = $data[0]['local_graph_id'];
	    $base = $data[0]['base_value'];
	    $title = $data[0]['title_cache'];

	    $ds_step = db_fetch_cell("SELECT
            				    data_template_data.rrd_step
            				FROM (
					    data_template_data,
					    data_template_rrd,
					    graph_templates_item
					    )
            				WHERE 
					    graph_templates_item.task_item_id=data_template_rrd.id and 
					    data_template_rrd.local_data_id=data_template_data.local_data_id and 
					    graph_templates_item.local_graph_id=$local_graph_id
            				limit 0,1");

	    $ds_step = empty($ds_step) ? 300 : $ds_step;	

	    $results[$title] = popen("$phppth ".dirname(__FILE__)."/sub_tot_traff_tree.php $local_data_id $start_time $end_time $ds_step","r");
	}

	$i = 0;
	$tot_in=$tot_out=0;
	foreach ($results as $title => $descriptor) {
		$data='';
	        if (!$descriptor) continue;
		while ($curr = fgets($descriptor))
		    $data .= $curr;
		pclose($descriptor);
		eval("\$bandwidth=$data;");

		$tot_in+=$bandwidth['traffic_in'];
		$tot_out+=$bandwidth['traffic_out'];
		
		$result[$i]['graph_title'] = $title;
		$result[$i]['traffic_in'] = HumanSize($bandwidth['traffic_in']);
		$result[$i]['traffic_out'] = HumanSize($bandwidth['traffic_out']);
	    $i++;
	}
	$result[]=array('TOTAL_IN'=>HumanSize($tot_in),'TOTAL_OUT'=>HumanSize($tot_out));
	return $result;
    }

print_r(getTraffic($_SERVER['argv'][1]));
?>
